std::is_polymorphic(3)

NAME
std::is_polymorphic - std::is_polymorphic

Synopsis
   Defined in header <type_traits>
   template< class T > (since C++11)
   struct is_polymorphic;
   If T is a polymorphic class (that is, a non-union class that declares or inherits at
   least one virtual function), provides the member constant value equal to true. For
   any other type, value is false.
   If T is a non-union class type, T shall be a complete type; otherwise, the behavior
   is undefined.
   The behavior of a program that adds specializations for is_polymorphic
   or is_polymorphic_v
   (since C++17) is undefined.

Template parameters
   T - a type to check
  Helper variable template
   template< class T > (since C++17)
   inline constexpr bool is_polymorphic_v = is_polymorphic<T>::value; Inherited from std::integral_constant

Member constants
   value true if T is a polymorphic class type , false otherwise
   [static] (public static member constant)

Member functions
   operator bool converts the object to bool, returns value
                 (public member function)
   operator() returns value
   (C++14) (public member function)

Member types
   Type Definition
   value_type bool
   type std::integral_constant<bool, value>

Possible implementation
   namespace detail {
   template <class T>
   std::true_type detect_is_polymorphic(
       decltype(dynamic_cast<const volatile void*>(static_cast<T*>(nullptr)))
   );
   template <class T>
   std::false_type detect_is_polymorphic(...);
   } // namespace detail
   template <class T>
   struct is_polymorphic : decltype(detail::detect_is_polymorphic<T>(nullptr)) {};

Example
// Run this code
 #include <iostream>
 #include <type_traits>
 struct A {
     int m;
 };
 struct B {
     virtual void foo();
 };
 struct C : B {};
 struct D {
     virtual ~D() = default;
 };
 int main()
 {
     std::cout << std::boolalpha
               << std::is_polymorphic<A>::value << ' '
               << std::is_polymorphic<B>::value << ' '
               << std::is_polymorphic<C>::value << ' '
               << std::is_polymorphic<D>::value << '\n';
 }

Output:
 false true true true

See also
   is_class checks if a type is a non-union class type
   (C++11) (class template)
   is_abstract checks if a type is an abstract class type
   (C++11) (class template)
   has_virtual_destructor checks if a type has a virtual destructor
   (C++11) (class template)